#include <stdio.h>
#include <stdlib.h>

#include "binary_tree.h"


int main( int argc, char** argv )
{
    // init. tree with empty root
    Tree* tree = initTree();

    // insert some values
    insert( tree, 42 );
    insert( tree, 47 );
    insert( tree, 11 );
    insert( tree, 9 );
    insert( tree, 8 );
    insert( tree, 14 );
    insert( tree, 13 );
    insert( tree, 5 );
    insert( tree, 14 );

    // print the tree content - sorted (in order)
    printTree( tree, INORDER );

    // print the tree content - DEPTH FIRST
    printTree( tree, DEPTH );
    printf( "tree size: %zu\n", treeSize( tree ) );

    // erase a value
    erase( tree, 14 );

    // check the resulting tree
    printTree( tree, DEPTH );
    printf( "tree size: %zu\n", treeSize( tree ) );

    // free resources
    deleteTree( tree );

    return EXIT_SUCCESS;
}
