#ifndef QUEUE_H
#define QUEUE_H 1

#include "binary_tree.h"

/**
 * A FIFO queue.
 */
struct _Queue;
typedef struct _Queue Queue;

/**
 * Initialize an empty queue.
 * \return the created queue
 */
Queue* initQueue( void );

/**
 * Append values (nodes from a binary tree) to the queue.
 * \param queue the queue
 * \param value the value that will be added
 */
void push( Queue* queue, Node* value );

/**
 * Remove and return the first element of the queue.
 * \param queue the queue
 */
Node* pop( Queue* queue );

/**
 * Get the number of elements stored in the queue.
 * \param queue the queue
 */
size_t queueSize( const Queue* queue );


/**
 * Delete all values stored in the queue and the queue itself.
 * \param queue the queue
 */
void deleteQueue( Queue* queue );

#endif /* QUEUE_H */
